com.r3corda.protocols / ResolveTransactionsProtocol

# ResolveTransactionsProtocol

`class ResolveTransactionsProtocol : ProtocolLogic<List<LedgerTransaction>>`

This protocol is used to verify the validity of a transaction by recursively checking the validity of all the dependencies. Once a transaction is checked its inserted into local storage so it can be relayed and wont be checked again.

A couple of constructors are provided that accept a single transaction. When these are used, the dependencies of that transaction are resolved and then the transaction itself is verified. Again, if successful, the results are inserted into the database as long as a SignedTransaction was provided. If only the WireTransaction form was provided then this isnt enough to put into the local database, so only the dependencies are checked and inserted. This way to use the protocol is helpful when resolving and verifying a finished but partially signed transaction.

The protocol returns a list of verified LedgerTransaction objects, in a depth-first order.

### Exceptions

ExcessivelyLargeTransactionGraph | `class ExcessivelyLargeTransactionGraph : Exception`

### Constructors

<init> | `ResolveTransactionsProtocol(stx: SignedTransaction, otherSide: Party)` `ResolveTransactionsProtocol(wtx: WireTransaction, otherSide: Party)` Resolve the full history of a transaction and verify it with its dependencies. `ResolveTransactionsProtocol(txHashes: Set<SecureHash>, otherSide: Party)` This protocol is used to verify the validity of a transaction by recursively checking the validity of all the dependencies. Once a transaction is checked its inserted into local storage so it can be relayed and wont be checked again.

### Properties

topic | `val topic: String` The topic to use when communicating with other parties. If more than one topic is required then use sub-protocols. Note that this is temporary until protocol sessions are properly implemented.
transactionCountLimit | `var transactionCountLimit: Int` The maximum number of transactions this protocol will try to download before bailing out.

### Inherited Properties

logger | `val logger: <ERROR CLASS>` This is where you should log things to.
progressTracker | `open val progressTracker: ProgressTracker?` Override this to provide a ProgressTracker. If one is provided and stepped, the framework will do something helpful with the progress reports. If this protocol is invoked as a sub-protocol of another, then the tracker will be made a child of the current step in the parent. If its null, this protocol doesnt track progress.
psm | `lateinit var psm: ProtocolStateMachine<*>` Reference to the Fiber instance that is the top level controller for the entire flow.
serviceHub | `val serviceHub: ServiceHub` Provides access to big, heavy classes that may be reconstructed from time to time, e.g. across restarts. It is only available once the protocol has started, which means it cannnot be accessed in the constructor. Either access this lazily or from inside call.

### Functions

call | `fun call(): List<LedgerTransaction>` This is where you fill out your business logic.

### Inherited Functions

receive | `fun <T : Any> receive(sessionIDForReceive: Long, receiveType: Class<T>): UntrustworthyData<T>` `fun <T : Any> receive(sessionIDForReceive: Long): UntrustworthyData<T>`
send | `fun send(destination: Party, sessionID: Long, payload: Any): Unit`
sendAndReceive | `fun <T : Any> sendAndReceive(destination: Party, sessionIDForSend: Long, sessionIDForReceive: Long, payload: Any): UntrustworthyData<T>`
subProtocol | `fun <R> subProtocol(subLogic: ProtocolLogic<R>): R` Invokes the given subprotocol by simply passing through this ProtocolLogics reference to the ProtocolStateMachine and then calling the call method.